import compose from 'koa-compose';
import redisMiddleware from './redis';
import limitMiddleware from './limit';
import logsMiddleware from './logs';
import responseMiddleware from './response';
import sessionMiddleware from './session';
// import authMiddleware from './auth';
import localDbMiddleware from './localDb';

export default (app, plugins) => {
  return compose([
    responseMiddleware(),
    logsMiddleware(plugins.logger.middleware),
    localDbMiddleware(plugins.db),
    redisMiddleware({
      redis: plugins.redis,
      memoryCache: plugins.memoryCache
    }),
    limitMiddleware(),
    sessionMiddleware(app)
  ]);
};
