import Nedb from 'nedb';
import { resolve } from 'path';

export interface InterfaceDB {
  [key: string]: Nedb
}
interface InterfaceLocalDb {
  [key: string]: string
}
class LocalDb {
  db: InterfaceDB
  constructor(options: InterfaceLocalDb) {
    const db: InterfaceDB = {};
    const { _dir, ...opts } = options;
    if (!_dir) {
      throw new Error('LocalDb options _dir is must have');
    }
    const filename = name => resolve(_dir, name);
    Object.entries(opts).forEach(([key, value]) => {
      db[key] = new Nedb({
        filename: filename(value),
        autoload: true
      });
    });
    this.db = db;
  }
}
export default LocalDb;
