// 内存存储
import nodeCache, { Options, NodeCacheLegacyCallbacks } from 'node-cache';
class MemoryCache {
  _cache: NodeCacheLegacyCallbacks
  constructor(options?: Options) {
    // 内存存储实例化
    this._cache = new nodeCache(options);
  }
  // 内存存储promise化，为了和redis使用方法保持一致
  get = (key: string): Promise<string|undefined> => {
    console.log(key);
    return new Promise(resolve => {
      resolve(this._cache.get(key));
    });
  }
  set = (key: string, ttl = 0, value: string): Promise<boolean> => {
    return new Promise((resolve, reject) => {
      const success = this._cache.set(key, value, ttl);
      if (success) {
        resolve(success);
      } else {
        reject(success);
      }
    });
  }
  setex = (key: string, ttl: number, value: string): Promise<boolean> => this.set(key, ttl, value)
}



export default MemoryCache;
