import { Sequelize } from 'sequelize';
import consola from 'consola';
import { formatLog } from './logger';
import c from '@/config';
const config = c.mysql;
const sequelize =  new Sequelize(config.database, config.username, config.password, {
  host: config.host,
  dialect: 'mysql',
  logging: msg => formatLog('info', msg)
});
(async() => {
  try {
    await sequelize.authenticate();
    consola.success('mysql数据库连接成功...');
  } catch (error) {
    consola.error('mysql数据库连接失败：');
    console.error(error);
  }
})();
export default sequelize;
