import { createCipheriv, createDecipheriv, scryptSync, createHash } from 'crypto';
import config from '@config';
import { createReadStream } from 'fs-extra';

const algorithm = 'aes-192-cbc';
const salt = '1a4d7g';
const key = scryptSync(config.secrestKey, salt, 24);
const iv = Buffer.alloc(16, '11');
// 加密
export const cipher = (data: string): string => {
  const cipher = createCipheriv(algorithm, key, iv);
  let enc = cipher.update(data, 'utf8', 'hex');
  enc += cipher.final('hex');
  return enc;
};
// 解密
export const decipher = (data: string): string => {
  const decipher = createDecipheriv(algorithm, key, iv);
  let dec = decipher.update(data, 'hex', 'utf8');
  dec += decipher.final('utf8');
  return dec;
};

// md5
export const calculateMd5 = (content: Buffer | string): string => {
  const hash = createHash('md5');
  return hash.update(content).digest('hex');
};

// md5 file
export const calculateFileMd5 = (path: string): Promise<string> => {
  return new Promise((resolve, reject) => {
    const hash = createHash('md5');
    const readStream = createReadStream(path);
    readStream.on('error', err => reject(err));
    readStream.on('data', data => hash.update(data));
    readStream.on('end', () => resolve(hash.digest('hex')));
  });
};
